package manager;

import java.awt.Point;
import java.io.File;

import main.BotMain;
import model.Map;
import model.World;
import msgs.BasicMsg;
import msgs.Message;

public class MenuManager extends ManagerBase 
{
	//--------------------------------------------------------------------
	public void receiveMessage (Message msg) 
	{
		switch (msg.getMsgType ())
		{
			case Message.MU_MSG_REQ_IDENTIFIKATION:
			{
				String maxrRevision = ((BasicMsg) msg).popString ();
				System.out.println ("MAXR Revision: " + maxrRevision);
				BotMain.getInstance ().playerNr = ((BasicMsg) msg).popInt16 ();
				System.out.println ("Received PlayerNr: " + BotMain.getInstance ().playerNr);
				BasicMsg identificationMsg = new BasicMsg (Message.MU_MSG_IDENTIFIKATION, BotMain.getInstance ().playerNr);
				identificationMsg.pushBoolean (true);
				identificationMsg.pushString (BotMain.getInstance ().botName);
				identificationMsg.pushInt16 (5);
				identificationMsg.pushInt16 (BotMain.getInstance ().playerNr);
				sendMessage (identificationMsg);
				
				BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
				chatMsg.pushString (BotMain.getInstance ().botName + ": Muhaha, finally I arrived!");
				chatMsg.pushBoolean (false);
				sendMessage (chatMsg);
				
				break;
			}
			case Message.MU_MSG_PLAYERLIST:
			{
				int oldNrPlayers = BotMain.getInstance ().nrPlayers;
				BotMain.getInstance ().nrPlayers = ((BasicMsg) msg).popInt16 ();
				
				if (oldNrPlayers != BotMain.getInstance ().nrPlayers)
				{
					BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
					chatMsg.pushString (BotMain.getInstance ().botName + ": So we play with " + BotMain.getInstance ().nrPlayers + " players. Let's rock.");
					chatMsg.pushBoolean (false);
					sendMessage (chatMsg);
				}
				break;
			}					
			case Message.MU_MSG_OPTINS:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
				if (basicMsg.popBoolean () == true) // options are sent
				{
					/*int duration = */basicMsg.popInt16 ();
					/*int victoryType = */basicMsg.popByte ();
					/*int metal = */basicMsg.popByte ();
					/*int oil = */basicMsg.popByte ();
					/*int gold = */basicMsg.popByte ();
					/*int density = */basicMsg.popByte ();							
					BotMain.getInstance ().credits = basicMsg.popInt16 ();
					/*boolean fixedBridgeHead = */basicMsg.popByte ();
					/*boolean alienTech = */basicMsg.popByte ();
					BotMain.getInstance ().clans = basicMsg.popByte ();
					/*boolean gameType = */basicMsg.popByte ();

					BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
					chatMsg.pushString (BotMain.getInstance ().botName + ": I like the new options. " + BotMain.getInstance ().credits + " Credits! >$-)");
					chatMsg.pushBoolean (false);
					sendMessage (chatMsg);
					chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
					chatMsg.pushString (BotMain.getInstance ().botName + ": I'll play brilliant with these!");
					chatMsg.pushBoolean (false);
					sendMessage (chatMsg);
				}
				if (basicMsg.popBoolean () == true) // map name is sent
				{
					String mapName = basicMsg.popString ();
					/*int mapCheckSum = */basicMsg.popInt32 ();
					System.out.println ("Mapname: " + mapName);
					File mapFile = new File (new File ("").getAbsoluteFile ().getParentFile (), "maps" + File.separatorChar + mapName);
					System.out.println ("File: " + mapFile.getAbsolutePath ());
					if (mapFile.exists ())
					{
						World.getWorld ().setMap (Map.loadMap (mapFile));
						if (World.getWorld ().getMap () != null)
						{
							BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
							chatMsg.pushString (BotMain.getInstance ().botName + ": Okidoki - the map looks cool!");
							chatMsg.pushBoolean (false);
							sendMessage (chatMsg);
							World.getWorld ().getMap ().analyzeMap ();
							World.getWorld ().getMap ().printMap ();
						}
						else
						{
							BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
							chatMsg.pushString (BotMain.getInstance ().botName + ": STRANGE - this map seems to be corrupt!");
							chatMsg.pushBoolean (false);
							sendMessage (chatMsg);									
						}
					}
					else
					{
						BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
						chatMsg.pushString (BotMain.getInstance ().botName + ": SORRY, I don't have that map...");
						chatMsg.pushBoolean (false);
						sendMessage (chatMsg);								
					}
				}
				if (basicMsg.popBoolean () == true) // a savegame name is sent
				{
					BotMain.getInstance ().isLoadedGame = true;
					BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
					chatMsg.pushString (BotMain.getInstance ().botName + ": Wanna continue that savegame? Have fun!");
					chatMsg.pushBoolean (false);
					sendMessage (chatMsg);															
				}
				break;
			}
			case Message.MU_MSG_GO:
			{
				if (BotMain.getInstance ().isLoadedGame == false)
				{
					try { Thread.sleep (1000); } catch (InterruptedException e) {}
					sendClan ();
					sendUpgradesAndLanding ();
					sendLandingCords ();
				}
				break;
			}
			case Message.MU_MSG_RESELECT_LANDING:
			{
				sendLandingCords ();
				break;
			}
			case Message.MU_MSG_CHAT:
			{
				/*bool translated = */((BasicMsg) msg).popBoolean ();
				String incomingMsg = ((BasicMsg) msg).popString ();
				System.out.println ("Incoming Chat: " + incomingMsg);
				if (((BasicMsg) msg).getPlayerNr () != BotMain.getInstance ().playerNr && incomingMsg.startsWith (BotMain.getInstance ().botName + ":") == false)
				{
					BasicMsg chatMsg = new BasicMsg (Message.MU_MSG_CHAT, BotMain.getInstance ().playerNr);
					chatMsg.pushString (BotMain.getInstance ().botName + ": So you want to chat? Go on... I listen carefully...");
					chatMsg.pushBoolean (false);
					sendMessage (chatMsg);
				}
				break;
			}
		}
	}
	
	//--------------------------------------------------------------------
	public void act () 
	{
	}

	//--------------------------------------------------------------------
	private void sendClan ()
	{
		if (BotMain.getInstance ().clans == BotMain.CLANS_ON)
		{
			BasicMsg clanMsg = new BasicMsg (Message.MU_MSG_CLAN, BotMain.getInstance ().playerNr);
			int myClan = (int)(Math.random () * 7.0);
			clanMsg.pushInt16 (myClan);
			clanMsg.pushInt16 (BotMain.getInstance ().playerNr);
			sendMessage (clanMsg);
			System.out.println ("Sent MU_MSG_CLAN: " + myClan);
		}
	}
	
	//--------------------------------------------------------------------
	private void sendUpgradesAndLanding ()
	{
		BasicMsg upgradeMsg = new BasicMsg (Message.MU_MSG_UPGRADES, BotMain.getInstance ().playerNr);
		// Missile Crawler
		upgradeMsg.pushInt16 (6); // speed
		upgradeMsg.pushInt16 (4); // scan
		upgradeMsg.pushInt16 (24); // max_hit_points		
		upgradeMsg.pushInt16 (4); // armor
		upgradeMsg.pushInt16 (6); // max_ammo
		upgradeMsg.pushInt16 (12); // range - normal: 10
		upgradeMsg.pushInt16 (1); // max_shots
		upgradeMsg.pushInt16 (26); // damage - normal: 22
		upgradeMsg.pushInt16 (21); // ID.iSecondPart 
		upgradeMsg.pushInt16 (0); // ID.iFirstPart
		upgradeMsg.pushBoolean (true); // is a vehicle 

		upgradeMsg.pushInt16 (1); // upgraded units
		upgradeMsg.pushInt16 (BotMain.getInstance ().playerNr); // playerNr		
		sendMessage (upgradeMsg);
		System.out.println ("Sent MU_MSG_UPGRADES");

		
		BasicMsg landingVehiclesMsg = new BasicMsg (Message.MU_MSG_LANDING_VEHICLES, BotMain.getInstance ().playerNr);
		
		landingVehiclesMsg.pushInt16 (21); //ID.iSecondPart // missile crawler
		landingVehiclesMsg.pushInt16 (0); // ID.iFirstPart 
		landingVehiclesMsg.pushInt16 (0); // cargo

		landingVehiclesMsg.pushInt16 (26); //ID.iSecondPart // scanner 
		landingVehiclesMsg.pushInt16 (0); // ID.iFirstPart 
		landingVehiclesMsg.pushInt16 (0); // cargo
		
		landingVehiclesMsg.pushInt16 (19); //ID.iSecondPart // constructor 
		landingVehiclesMsg.pushInt16 (0); // ID.iFirstPart 
		landingVehiclesMsg.pushInt16 (40); // cargo
		
		landingVehiclesMsg.pushInt16 (24); //ID.iSecondPart // pioneer 
		landingVehiclesMsg.pushInt16 (0); // ID.iFirstPart 
		landingVehiclesMsg.pushInt16 (40); // cargo

		landingVehiclesMsg.pushInt16 (31); //ID.iSecondPart // surveyor 
		landingVehiclesMsg.pushInt16 (0); // ID.iFirstPart 
		landingVehiclesMsg.pushInt16 (0); // cargo


		landingVehiclesMsg.pushInt16 (5); // nr vehicles
		landingVehiclesMsg.pushInt16 (BotMain.getInstance ().playerNr);
		sendMessage (landingVehiclesMsg);
		System.out.println ("Sent MU_MSG_LANDING_VEHICLES");
	}
	
	//--------------------------------------------------------------------
	private void sendLandingCords ()
	{
		Point startingPlace = new Point (0, 0);
		if (World.getWorld ().getMap () != null)
			startingPlace = World.getWorld ().getMap ().findStartingPlace ();
		
		BasicMsg landingCoordsMsg = new BasicMsg (Message.MU_MSG_LANDING_COORDS, BotMain.getInstance ().playerNr);
		landingCoordsMsg.pushInt16 (startingPlace.y);
		landingCoordsMsg.pushInt16 (startingPlace.x);
		landingCoordsMsg.pushByte (BotMain.getInstance ().playerNr);
		sendMessage (landingCoordsMsg);
		System.out.println ("Sent starting place: x " + startingPlace.x + "  y " + startingPlace.y);
	}
}
