package manager;

import main.BotMain;
import model.Unit;
import msgs.BasicMsg;
import msgs.Message;

//--------------------------------------------------------------------
public class MilitaryManager extends ManagerBase 
{
	
	//--------------------------------------------------------------------
	public void receiveMessage (Message msg) 
	{
		switch (msg.getMsgType ())
		{
			case Message.GAME_EV_ADD_VEHICLE:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
				boolean init = basicMsg.popBoolean ();
				int owner = basicMsg.popInt16 ();
				int unitIDFirstPart = basicMsg.popInt16 ();						
				int unitIDSecPart = basicMsg.popInt16 ();
				int posY = basicMsg.popInt16 ();
				int posX = basicMsg.popInt16 ();
				int iId = basicMsg.popInt16 ();
				boolean addToMap = basicMsg.popBoolean ();
				System.out.println ("Received GAME_EV_ADD_VEHICLE (iId=" + iId + ") at " 
						+ posX + "/" + posY + " of type " + unitIDFirstPart +"," + unitIDSecPart + " of player " + owner
						+ " (addToMap=" + addToMap + ", init=" + init + ")");
				
				Unit newUnit = new Unit (unitIDFirstPart, unitIDSecPart, iId, posX, posY, owner);
				BotMain.getInstance ().world.addUnit (newUnit);
				
				ManagerUtils.sendSetSentry (newUnit);
				break;
			}
			case Message.GAME_EV_ADD_ENEM_VEHICLE:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
				int owner = basicMsg.popInt16 ();
				int unitIDFirstPart = basicMsg.popInt16 ();						
				int unitIDSecPart = basicMsg.popInt16 ();
				int posY = basicMsg.popInt16 ();
				int posX = basicMsg.popInt16 ();
				/*int dir =*/ basicMsg.popInt16 ();
				int iId = basicMsg.popInt16 ();
				System.out.println ("Received GAME_EV_ADD_ENEM_VEHICLE (iId=" + iId + ") at " 
						+ posX + "/" + posY + " of type " + unitIDFirstPart +"," + unitIDSecPart + " of player " + owner + ")");
				
				Unit newUnit = new Unit (unitIDFirstPart, unitIDSecPart, iId, posX, posY, owner);
				BotMain.getInstance ().world.addUnit (newUnit);
				break;
			}
			case Message.GAME_EV_UNIT_DATA:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
		
				int owner = basicMsg.popInt16 ();
				int iId = basicMsg.popInt16 ();
				boolean isVehicle = basicMsg.popBoolean ();
				int posY = basicMsg.popInt16 ();
				int posX = basicMsg.popInt16 ();
				/*boolean isBig = */basicMsg.popBoolean ();
				boolean sentName = basicMsg.popBoolean ();
				String name = "OriginalName";
				if (sentName)
					name = basicMsg.popString ();
				/*boolean isBeeingAttacked = */basicMsg.popBoolean ();
				/*int disabled = */basicMsg.popInt16 ();
				/*int commandoRank = */basicMsg.popInt16 ();
				/*boolean isClearing =*/ basicMsg.popBoolean ();
				/*boolean isBuilding =*/ basicMsg.popBoolean ();
				/*int buildRounds =*/ basicMsg.popInt16 ();
				/*int clearingRounds =*/ basicMsg.popInt16 ();
				boolean sentryStatus = basicMsg.popBoolean ();
				System.out.println ("Received GAME_EV_UNIT_DATA for " + name + " (iId=" + iId + ",vehicle=" + isVehicle + ") at " 
						+ posX + "/" + posY + " of player " + owner + " sentry=" + sentryStatus);
				
				Unit changedUnit = BotMain.getInstance ().world.findUnit (iId);
				if (changedUnit != null)
				{
					changedUnit.setPosition (posX, posY);
					changedUnit.setSentryState (sentryStatus);
					changedUnit.setBuildCosts (basicMsg.popInt16 ());
					int ammo = basicMsg.popInt16 ();
					changedUnit.setMaxAmmo (basicMsg.popInt16 ());
					changedUnit.setAmmo (ammo);
					int cargo = basicMsg.popInt16 ();
					changedUnit.setMaxCargo (basicMsg.popInt16 ());
					changedUnit.setCargo (cargo);

					// int storedUnits = basicMsg.popInt16 ();
					// changedUnit.setMaxStoredUnits (basicMsg.popInt16 ());					
					// changedUnit.setStoredUnits (storedUnits);
					basicMsg.popInt16 (); // stored units
					basicMsg.popInt16 (); // stored units max
					
					changedUnit.setDamage (basicMsg.popInt16 ());
					int shots = basicMsg.popInt16 ();
					changedUnit.setMaxShots (basicMsg.popInt16 ());
					changedUnit.setShots (shots);
					changedUnit.setRange (basicMsg.popInt16 ());
					changedUnit.setScan (basicMsg.popInt16 ());
					changedUnit.setArmor (basicMsg.popInt16 ());
					int hitPoints = basicMsg.popInt16 ();
					changedUnit.setMaxHitPoints (basicMsg.popInt16 ());
					changedUnit.setHitPoints (hitPoints);
					//changedUnit.setVersion (basicMsg.popInt16 ());
					basicMsg.popInt16 (); // version
					int speed = basicMsg.popInt16 ();
					changedUnit.setMaxSpeed (basicMsg.popInt16 ());
					changedUnit.setSpeed (speed);
				}
				break;
			}
			case Message.GAME_EV_ATTACKJOB_FIRE:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
				int attackJobID = basicMsg.popInt16 ();
				sendAttackJobFinished (attackJobID);						
				break;
			}
			case Message.GAME_EV_NEXT_MOVE:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
				int vehicleID = basicMsg.popInt16 ();
				int newX = basicMsg.popInt16 ();				
				int newY = basicMsg.popInt16 ();
				int moveType = basicMsg.popByte ();
				
				Unit unit = BotMain.getInstance ().world.findUnit (vehicleID);
				if (unit != null)
				{
					unit.setPosition (newX, newY);
					unit.setIsMoving (moveType == 0); // 0 == MJOB_OK
				}
				break;
			}
		}
	}

	//--------------------------------------------------------------------
	private void sendAttackJobFinished (int attackJobID)
	{
		BasicMsg attackJobFinishedMsg = new BasicMsg (Message.GAME_EV_ATTACKJOB_FINISHED, BotMain.getInstance ().playerNr);
		attackJobFinishedMsg.pushInt16 (attackJobID);
		sendMessage (attackJobFinishedMsg);
		System.out.println ("Sent GAME_EV_ATTACKJOB_FINISHED for attackJob " + attackJobID);
	}

	//--------------------------------------------------------------------
	public void act () 
	{
	}
}
