package manager;

import java.util.ArrayList;

import main.BotMain;
import model.Map;
import model.Unit;
import model.World;
import msgs.BasicMsg;
import msgs.Message;

//--------------------------------------------------------------------
public class ResourceExplorationManager extends ManagerBase 
{
	//--------------------------------------------------------------------
	public void receiveMessage (Message msg) 
	{
		switch (msg.getMsgType ())
		{
			case Message.GAME_EV_RESOURCES:
			{
				BasicMsg basicMsg = (BasicMsg) msg;
				Map map = World.getWorld ().getMap ();
				if (map != null)
				{
					int nrResInfos = basicMsg.popInt16 ();
					for (int i = 0; i < nrResInfos; i++)
					{
						int index = basicMsg.popInt32 ();
						byte type = (byte)(basicMsg.popInt16 () + 1);
						byte ammount = (byte)basicMsg.popInt16 ();
						int y = index / map.getWidth ();
						int x = index - y * map.getWidth ();
						System.out.println ("Received Resource at " + index + "  " + x + "/" + y + " type: " + type + " ammount: " + ammount);
						map.setResource (x, y, type, ammount);
					}
				}
				break;
			}
		}
	}

	//--------------------------------------------------------------------
	long lastActionTime = 0; // milli seconds
	boolean acted = false;
	//--------------------------------------------------------------------
	public void act ()
	{
		long currentTime = System.currentTimeMillis ();
		if (currentTime - lastActionTime > 2000 && acted == false)
		{
			ArrayList<Unit> surveyors = BotMain.getInstance ().world.getSurveyors (BotMain.getInstance ().playerNr);
			for (int i = 0; i < surveyors.size (); i++)
			{
				Unit surveyor = surveyors.get (i);
				if (surveyor.getSpeed () > 0)
					moveSurveyor (surveyor);
				acted = true;
			}

			lastActionTime = currentTime;
		}
	}
	
	//--------------------------------------------------------------------
	private void moveSurveyor (Unit surveyor)
	{
		Map map = World.getWorld ().getMap ();
		
		BasicMsg moveJobMsg = new BasicMsg (Message.GAME_EV_MOVE_JOB_CLIENT, BotMain.getInstance ().playerNr);
		moveJobMsg.pushInt16 (4); // costs of waypoint
		moveJobMsg.pushInt32 (surveyor.getX () - 1 + surveyor.getY () * map.getWidth ());
		moveJobMsg.pushInt16 (0); // costs of waypoint
		moveJobMsg.pushInt32 (surveyor.getX () + surveyor.getY () * map.getWidth ());
		moveJobMsg.pushInt16 (2); // number of waypoints
		moveJobMsg.pushBoolean (false); // not a plane
		moveJobMsg.pushInt32 (surveyor.getX () - 1 + surveyor.getY () * map.getWidth ());
		moveJobMsg.pushInt32 (surveyor.getX () + surveyor.getY () * map.getWidth ());
		moveJobMsg.pushInt16 (surveyor.getID ());
		sendMessage (moveJobMsg);
		
		surveyor.setIsMoving (true);
		System.out.println ("Sent GAME_EV_MOVE_JOB_CLIENT");
	}

}
