package manager;

import main.BotMain;
import model.Unit;
import msgs.BasicMsg;
import msgs.Message;

//--------------------------------------------------------------------
public class StandardManager extends ManagerBase
{
	//--------------------------------------------------------------------
	public void receiveMessage (Message msg) 
	{
		switch (msg.getMsgType ())
		{
			case Message.GAME_EV_FINISHED_TURN:
			{
				checkSentryState ();
				sendFinishedTurn ();
				break;
			}
		}
	}

	//--------------------------------------------------------------------
	public void act () 
	{
	}
	
	//--------------------------------------------------------------------
	private void checkSentryState ()
	{
		int nrOfMyUnits = BotMain.getInstance ().world.getNrOfUnits (BotMain.getInstance ().playerNr);
		for (int i = 0; i < nrOfMyUnits; i++)
		{
			Unit unit = BotMain.getInstance ().world.getUnit (i, BotMain.getInstance ().playerNr);
			if (unit != null && unit.getDamage () > 0 && unit.getSentryState () == false)
				ManagerUtils.sendSetSentry (unit);
		}
	}

	//--------------------------------------------------------------------
	private void sendFinishedTurn ()
	{
		BasicMsg endTurnMsg = new BasicMsg (Message.GAME_EV_WANT_TO_END_TURN, BotMain.getInstance ().playerNr);
		sendMessage (endTurnMsg);
		System.out.println ("Sent GAME_EV_WANT_TO_END_TURN");		
	}

}
