package model;

//--------------------------------------------------------------------
public class Unit 
{
	//--------------------------------------------------------------------
	public Unit (int typeFirstPart, int typeSecondPart, int iID, int x, int y, int owner)
	{
		setType (new UnitType (typeFirstPart, typeSecondPart));
		setID (iID);
		setOwner (owner);
		setPosition (x, y);
		initUnit ();
	}
	
	public UnitType getType () { return type; }
	public void setType (UnitType newType) { type = newType; }
	public boolean isVehicle () { return type.firstPart == 0; }
	public boolean isRoad () { return type.firstPart == 1 && type.secondPart == 28; }
	private UnitType type;
	
	//--------------------------------------------------------------------
	public boolean blocksWayForUnit (Unit otherUnit)
	{
		// TODO
		return false;
	}

	//--------------------------------------------------------------------
	public int getID () { return iID; }
	public void setID (int newID) { iID = newID; }
	private int iID;
	
	//--------------------------------------------------------------------
	public void setPosition (int x, int y) { this.x = x; this.y = y; }
	public int getX () { return x; }
	public void setX (int newX) { x = newX; }
	public int getY () { return y; }
	public void setY (int newY) { y = newY; }
	private int x;
	private int y;

	//--------------------------------------------------------------------
	public int getOwner () { return owner; }
	public void setOwner (int newOwner) { owner = newOwner; }
	private int owner;

	//--------------------------------------------------------------------
	public int getMaxHitPoints () { return maxHitPoints; } 
	public void setMaxHitPoints (int newMaxHitPoints) { maxHitPoints = newMaxHitPoints; }
	public int getHitPoints () { return hitPoints; } 
	public void setHitPoints (int newHitPoints) { hitPoints = newHitPoints; }
	private int maxHitPoints;
	private int hitPoints;
	
	//--------------------------------------------------------------------
	public int getMaxSpeed () { return maxSpeed; }
	public void setMaxSpeed (int newMaxSpeed) { maxSpeed = newMaxSpeed; }
	public int getSpeed () { return speed; }
	public void setSpeed (int newSpeed) { speed = newSpeed; }
	public boolean isMoving () { return isMoving; }
	public void setIsMoving (boolean state) { isMoving = state; }
	private boolean isMoving = false;
	private int maxSpeed;
	private int speed;
	
	//--------------------------------------------------------------------
	public int getArmor () { return armor; }
	public void setArmor (int newArmor) { armor = newArmor; }
	private int armor;
	
	//--------------------------------------------------------------------
	public int getScan () { return scan; }
	public void setScan (int newScan) { scan = newScan; }
	private int scan;

	//--------------------------------------------------------------------
	public int getRange () { return range; }
	public void setRange (int newRange) { range = newRange; }
	private int range;

	//--------------------------------------------------------------------
	public int getMaxShots () { return maxShots; }
	public void setMaxShots (int newMaxShots) { maxShots = newMaxShots; }
	public int getShots () { return shots; }
	public void setShots (int newShots) { shots = newShots; }
	private int maxShots;
	private int shots;

	//--------------------------------------------------------------------
	public int getDamage () { return damage; }
	public void setDamage (int newDamage) { damage = newDamage; }
	private int damage;

	//--------------------------------------------------------------------
	public int getMaxAmmo () { return maxAmmo; }
	public void setMaxAmmo (int newMaxAmmo) { maxAmmo = newMaxAmmo; }
	public int getAmmo () { return ammo; }
	public void setAmmo (int newAmmo) { ammo = newAmmo; }
	private int maxAmmo;
	private int ammo;

	//--------------------------------------------------------------------
	public int getMaxCargo () { return maxCargo; }
	public void setMaxCargo (int newMaxCargo) 
	{ 
		maxCargo = newMaxCargo; 
		if (getCargo () > maxCargo)
			setCargo (maxCargo);
	}
	public int getCargo () { return cargo; }
	public void setCargo (int newCargo) 
	{ 
		cargo = newCargo;
		if (cargo > getMaxCargo ())
			cargo = getMaxCargo ();
	}
	private int maxCargo;
	private int cargo;

	//--------------------------------------------------------------------
	public int getBuildCosts () { return buildCosts; }
	public void setBuildCosts (int newBuildCosts) { buildCosts = newBuildCosts; }
	private int buildCosts;
	
	//--------------------------------------------------------------------
	public boolean getSentryState () { return sentryState; }
	public void setSentryState (boolean newSentryState) { sentryState = newSentryState; }
	private boolean sentryState;
	
	//--------------------------------------------------------------------
	private void initUnit ()
	{
		// TODO: read from standard unit stats
		setSentryState (false);
		setMaxCargo (0);
		setCargo (0);
		setBuildCosts (0);
		setIsMoving (false);
		//...
	}
	
}
