package model;

import java.util.ArrayList;

//--------------------------------------------------------------------
public class UnitsOnSquare {

	//--------------------------------------------------------------------
	private ArrayList<Unit> units = null;
	
	//--------------------------------------------------------------------
	public UnitsOnSquare () {}
	
	//--------------------------------------------------------------------
	public boolean isEmpty () { return (units == null || units.size () == 0); }

	//--------------------------------------------------------------------
	public boolean hasRoad ()
	{
		if (units == null)
			return false;
		for (int i = 0; i < units.size (); i++)
		{
			Unit unit = units.get (i);
			if (unit.isRoad ())
				return true;
		}
		return false;
	}

	//--------------------------------------------------------------------
	public boolean isBlockedForUnit (Unit otherUnit)
	{
		if (units == null)
			return false;
		for (int i = 0; i < units.size (); i++)
		{
			Unit unit = units.get (i);
			if (unit.blocksWayForUnit (otherUnit))
				return true;
		}
		return false;		
	}

	//--------------------------------------------------------------------
	public void addUnit (Unit unit)
	{
		if (units == null)
			units = new ArrayList<Unit> ();
		// TODO: sort like this: road/bridge/waterplatform, connector, buildings, units
		units.add (unit);
	}
	
	//--------------------------------------------------------------------
	public Unit getUnit (int index)
	{
		if (units == null || index < 0 || index >= units.size ())
			return null;
		return units.get (index);
	}
	
	//--------------------------------------------------------------------
	public int getNrUnits ()
	{
		if (units == null)
			return 0;
		return units.size ();
	}
	
}
