package model;

import java.util.ArrayList;

import main.BotMain;

//--------------------------------------------------------------------
public class World 
{
	//--------------------------------------------------------------------
	public static World getWorld ()
	{
		return BotMain.getInstance ().world;
	}
	
	//--------------------------------------------------------------------
	private Map map = null;
	private ArrayList<Unit> units = new ArrayList<Unit>();
	private UnitsOnSquare[] unitsOnSquare = null;	

	//--------------------------------------------------------------------
	public Map getMap () 
	{ 
		if (map == null)
		{
			System.out.println ("ERROR: World.getMap (): using map, before it was loaded!!!");
			map = new Map (5, 5); // if no map was loaded yet, create a dummy map
		}
		return map; 
	}
	public void setMap (Map newMap)	
	{ 
		map = newMap; 
		unitsOnSquare = new UnitsOnSquare[newMap.getWidth () * newMap.getHeight ()];
		for (int i = 0; i < unitsOnSquare.length; i++)
			unitsOnSquare[i] = null;
	}

	//--------------------------------------------------------------------
	public UnitsOnSquare getUnitsOnSquare (int x, int y)
	{
		if (unitsOnSquare == null || getMap ().areValidCoords (x, y) == false 
			|| unitsOnSquare[getMap ().getMapOffset (x, y)] == null) // no units there, return an empty object
			return new UnitsOnSquare ();
		else 
			return unitsOnSquare[getMap ().getMapOffset (x, y)];
	}	
	
	//--------------------------------------------------------------------
	public void addUnit (Unit unit)
	{
		if (findUnit (unit.getID ()) == null)
			units.add (unit);
	}
	
	//--------------------------------------------------------------------
	public Unit findUnit (int iID)
	{
		for (int i = 0; i < units.size (); i++)
		{
			if (units.get (i).getID () == iID)
				return units.get (i);
		}
		return null;
	}
	
	//--------------------------------------------------------------------
	public int getNrOfUnits (int owner)
	{
		int result = 0;
		for (int i = 0; i < units.size (); i++)
		{
			if (units.get (i).getOwner () == owner)
				result++;
		}
		return result;
	}
	
	//--------------------------------------------------------------------
	public Unit getUnit (int index, int owner)
	{
		int count = 0;
		for (int i = 0; i < units.size (); i++)
		{
			if (units.get (i).getOwner () == owner)
			{
				if (count == index)
					return units.get (i);
				count++;
			}
		}
		return null;
	}
	
	//--------------------------------------------------------------------
	public ArrayList<Unit> getSurveyors (int owner)
	{
		ArrayList<Unit> result = new ArrayList<Unit> ();
		for (int i = 0; i < units.size (); i++)
		{
			if (units.get (i).getOwner () == owner
				&& units.get (i).getType ().firstPart == 0
				&& units.get (i).getType ().secondPart == 31)
					result.add (units.get (i));
		}
		return result;
	}	
	
}
