package msgs;

import java.io.OutputStream;

//--------------------------------------------------------------------
public interface Message 
{
	//--------------------------------------------------------------------
	public int getMsgType ();
	public void reinitMsgStream ();
	public boolean writeToStream (OutputStream output);

	//--------------------------------------------------------------------
	public static final int MSG_UNKNOWN = -1;
	
	public static final int MU_MSG_CHAT = 1000;
	public static final int MU_MSG_NEW_PLAYER = 1001;
	public static final int MU_MSG_REQ_IDENTIFIKATION = 1002;	
	public static final int MU_MSG_IDENTIFIKATION = 1003;
	public static final int MU_MSG_DEL_PLAYER = 1004;
	public static final int MU_MSG_PLAYERLIST = 1005;
	public static final int MU_MSG_OPTINS = 1006;
	public static final int MU_MSG_START_MAP_DOWNLOAD = 1007;	
	public static final int MU_MSG_MAP_DOWNLOAD_DATA = 1008;
	public static final int MU_MSG_CANCELED_MAP_DOWNLOAD = 1009;
	public static final int MU_MSG_FINISHED_MAP_DOWNLOAD = 1010;
	public static final int MU_MSG_GO = 1011;
	public static final int MU_MSG_CLAN = 1012;
	public static final int MU_MSG_REQUEST_MAP = 1013;
	public static final int MU_MSG_LANDING_VEHICLES = 1014;	// the list of purchased vehicles
	public static final int MU_MSG_UPGRADES = 1015;			// data of upgraded units
	public static final int GAME_EV_REQ_IDENT = 1016;      	// a server of a running game requests an identification
	public static final int GAME_EV_RECON_IDENT = 1017;		// a server of a running game requests an identification of a player who wants to reconnect
	public static final int MU_MSG_LANDING_COORDS = 1018; 	// the selected landing coordinates of a client
	public static final int MU_MSG_RESELECT_LANDING = 1019;	// informs a client that the player has to reselect the landing site
	public static final int MU_MSG_ALL_LANDED = 1020;		// all players have selected there landing points and clients can start game	

	public static final int GAME_EV_LOST_CONNECTION = 0;	// connection on a socket has been lost
	public static final int GAME_EV_CHAT_CLIENT = 1;			// a chat message from client to server
	public static final int GAME_EV_WANT_TO_END_TURN = 2;		// a client wants to end the turn
	public static final int GAME_EV_WANT_START_WORK = 3;		// a client wants to start a building
	public static final int GAME_EV_WANT_STOP_WORK = 4;			// a client wants to stop a building
	public static final int GAME_EV_MOVE_JOB_CLIENT = 5;		// a message with all waypoints
	public static final int GAME_EV_WANT_STOP_MOVE = 6;			// a client wants to stop a moving vehicle
	public static final int GAME_EV_WANT_ATTACK = 7;			// a client wants to attack an other unit
	public static final int GAME_EV_MINELAYERSTATUS = 8;		// a minelayer changes his laying status
	public static final int GAME_EV_ATTACKJOB_FINISHED = 9;		// the client has finished animating the muzzle flash
	public static final int GAME_EV_WANT_BUILD = 10;			// a vehicle wants to start building a building
	public static final int GAME_EV_END_BUILDING = 11;			// a vehicle has finished building and will leave the building lot now
	public static final int GAME_EV_WANT_STOP_BUILDING = 12;	// a vehicle wants to stop building
	public static final int GAME_EV_WANT_TRANSFER = 13;			// information about a resource transfer
	public static final int GAME_EV_WANT_BUILDLIST = 14;		// a building wants his buildlist to be verified by the server and start work
	public static final int GAME_EV_WANT_EXIT_FIN_VEH = 15;		// a client wants to exit a finished vehicle out of a building
	public static final int GAME_EV_CHANGE_RESOURCES = 16;		// a client wants to change his resource production
	public static final int GAME_EV_WANT_CHANGE_SENTRY = 17;	// a client wants to change the sentry status of a unit
	public static final int GAME_EV_WANT_MARK_LOG = 18;			// marks a position in the log file
	public static final int GAME_EV_WANT_SUPPLY = 19;			// a client wants to rearm or repair a unit
	public static final int GAME_EV_WANT_VEHICLE_UPGRADE = 20;	// a client wants to upgrade a vehicle in a building to the newest version
	public static final int GAME_EV_WANT_START_CLEAR = 21;		// a bulldowzer wants to start clearing the field under his position
	public static final int GAME_EV_WANT_STOP_CLEAR = 22;		// a bulldowzer wants to stop the clearing
	public static final int GAME_EV_ABORT_WAITING = 23;			// the player wants to abort waiting for the reconnect of a disconnected player
	public static final int GAME_EV_IDENTIFICATION = 24;		// a message with the name of the player who wants to reconnect
	public static final int GAME_EV_RECON_SUCESS = 25;			// a client has reconnected sucsessfuly and is ready to receive his game data
	public static final int GAME_EV_WANT_LOAD = 26;				// a client wants to load a unit into another
	public static final int GAME_EV_WANT_EXIT = 27;				// a client wants to exit a stored unit
	public static final int GAME_EV_REQUEST_RESYNC = 28;		// requests the server to resync a client
	public static final int GAME_EV_WANT_BUY_UPGRADES = 29;		// a client wants to buy gold upgrades for units
	public static final int GAME_EV_WANT_BUILDING_UPGRADE = 30;	// a client wants to upgrade one or more buildings to the newest version
	public static final int GAME_EV_WANT_RESEARCH_CHANGE = 31;	// a client wants to change the research assignments of his research centers
	public static final int GAME_EV_AUTOMOVE_STATUS = 32;		// a unit has been set to automoving
	public static final int GAME_EV_SAVE_HUD_INFO = 33;			// the current hud settings
	public static final int GAME_EV_SAVE_REPORT_INFO = 34;		// a saved report
	public static final int GAME_EV_FIN_SEND_SAVE_INFO = 35;	// a unit has been set to automoving
	public static final int GAME_EV_WANT_COM_ACTION  = 36;		// an infiltrator wants to steal or disable another unit
	public static final int GAME_EV_WANT_SELFDESTROY = 37;
	public static final int GAME_EV_WANT_CHANGE_UNIT_NAME = 38;	// the player wants to change the name of an unit
	public static final int GAME_EV_END_MOVE_ACTION = 39;		// specifies an action, which will be executed at the end of a movejob
	
	
	public static final int GAME_EV_ADD_BUILDING = 50;	// adds a building
	public static final int GAME_EV_ADD_VEHICLE = 51;			// adds a vehicle
	public static final int GAME_EV_DEL_BUILDING = 52;			// deletes a building
	public static final int GAME_EV_DEL_VEHICLE = 53;			// deletes a vehicle
	public static final int GAME_EV_ADD_ENEM_BUILDING = 54;		// adds a enemy building with current data
	public static final int GAME_EV_ADD_ENEM_VEHICLE = 55;		// adds a vehicle with current data
	public static final int GAME_EV_PLAYER_CLANS = 56;			// data about the clans of the players
	public static final int GAME_EV_CHAT_SERVER = 57;			// a chat message from server to client
	public static final int GAME_EV_MAKE_TURNEND = 58;			// a player has to do actions for a turn ending
	public static final int GAME_EV_FINISHED_TURN = 59;			// a player has finished his turn
	public static final int GAME_EV_UNIT_DATA = 60;				// set new data values for a vehicle
	public static final int GAME_EV_SPECIFIC_UNIT_DATA = 61;		// more specific unit values which are only for the owner
	public static final int GAME_EV_UNIT_UPGRADE_VALUES = 62;	// message contains upgraded values for a unit
	public static final int GAME_EV_DO_START_WORK = 63;			// starts a building
	public static final int GAME_EV_DO_STOP_WORK = 64;			// stops a building
	public static final int GAME_EV_NEXT_MOVE = 65;				// infos about the next move
	public static final int GAME_EV_MOVE_JOB_SERVER = 66;		// a message with all waypoints
	public static final int GAME_EV_ATTACKJOB_LOCK_TARGET = 67;	// prepares a mapsquare for beeing attacked
	public static final int GAME_EV_ATTACKJOB_FIRE = 68;			// plays the muzzle flash on a client
	public static final int GAME_EV_ATTACKJOB_IMPACT = 69;		// makes impact and target unlocking of an attackjob
	public static final int GAME_EV_RESOURCES = 70;				// a message with new scaned resources for a client
	public static final int GAME_EV_BUILD_ANSWER = 71;			// the answer of the server to a build request of a client
	public static final int GAME_EV_STOP_BUILD = 72;				// a vehicle has to stop building
	public static final int GAME_EV_SUBBASE_VALUES = 73;			// the values of a subbase
	public static final int GAME_EV_BUILDLIST = 74;				// the buildlist of a building
	public static final int GAME_EV_MINE_PRODUCE_VALUES = 75;	// the produce values of a mine
	public static final int GAME_EV_TURN_REPORT = 76;			// the turnstartreport of a player
	public static final int GAME_EV_MARK_LOG = 77;				// marks a position in the logfile
	public static final int GAME_EV_SUPPLY = 78;					// rearms or repairs a unit
	public static final int GAME_EV_ADD_RUBBLE = 79;				// adds a rubble field to the client
	public static final int GAME_EV_DETECTION_STATE = 80;		// informs a client wether a vehicle has been detected
	public static final int GAME_EV_CLEAR_ANSWER = 81;			// the answer to a clearing request
	public static final int GAME_EV_STOP_CLEARING = 82;			// a bulldowzer has to stop clearing
	public static final int GAME_EV_NOFOG = 83;					// the player can disable his fog
	public static final int GAME_EV_DEFEATED = 84;				// a player has been defeated
	public static final int GAME_EV_WAIT_RECON = 85;			// a client has to wait for a reconnection
	public static final int GAME_EV_ABORT_WAIT_RECON = 86;		// a client has to finish waiting for a reconnection
	public static final int GAME_EV_FREEZE = 87;				// a client has to be freezed
	public static final int GAME_EV_UNFREEZE = 88;				// a client has to be defreezed
	public static final int GAME_EV_WAIT_FOR = 89;				// a client has to wait for an other player to finish his turn	
	public static final int GAME_EV_DEL_PLAYER = 90;				// a client has to delete a player
	public static final int GAME_EV_TURN = 91;					// a message with the current turn
	public static final int GAME_EV_HUD_SETTINGS = 92;			// hud settings for a client
	public static final int GAME_EV_STORE_UNIT = 93;				// a unit has to be stored
	public static final int GAME_EV_EXIT_UNIT = 94;				// a unit has to be exit
	public static final int GAME_EV_DELETE_EVERYTHING = 95;		// a client has to delete all units to be ready for a resync
	public static final int GAME_EV_CREDITS_CHANGED = 96;		// the credits of a player changed (e.g. because he bought upgrades)
	public static final int GAME_EV_UPGRADED_BUILDINGS = 97;		// the buildings in the msg have been upgraded to the current version
	public static final int GAME_EV_UPGRADED_VEHICLES = 98;		// the vehicles in the msg have been upgraded to the current version
	public static final int GAME_EV_RESEARCH_SETTINGS = 99;		// the research centers were newly assigned to research areas
	public static final int GAME_EV_RESEARCH_LEVEL = 100;			// the research level reached by a player
	public static final int GAME_EV_REFRESH_RESEARCH_COUNT = 101;	// the client has to refresh the researchCount and the research sums for the areas after a resync
	public static final int GAME_EV_SET_AUTOMOVE = 102;			// a unit has to enable automoving
	public static final int GAME_EV_COMMANDO_ANSWER = 103;		// information about the result of a commando action
	public static final int GAME_EV_REQ_SAVE_INFO = 104;			// request the hud state and the saved reports from a client
	public static final int GAME_EV_SAVED_REPORT = 105;			// sends saved reports to a client
	public static final int GAME_EV_SCORE = 106;                  // sends a player's score to a client
	public static final int GAME_EV_NUM_ECOS = 107;               // sends a player's ecosphere count to a client
	public static final int GAME_EV_UNIT_SCORE = 108;             // sends a unit's score to its owner
	public static final int GAME_EV_VICTORY_CONDITIONS = 109;     // the game's victory conditions
	public static final int GAME_EV_SELFDESTROY = 110;
	public static final int DEBUG_CHECK_VEHICLE_POSITIONS = 111;	// sends all vehicle positions to the clients to find async vehicles
}
